<template>
  <v-dialog
    :value="value"
    max-width="290"
    @click:outside="closeRequest"
    @keydown.esc="closeRequest"
    content-class="round"
  >
    <v-form
      lazy-validation
      ref="form"
      v-model="valid"
      @submit.prevent="onSubmit"
    >
      <div class="flex flex-col bg-white p-7 justify-between gap-8">
        <div class="flex flex-row justify-center">
          <div class="text-xl font-semibold">
            {{ updating ? `Modifier l'élève` : "Ajouter un élève" }}
          </div>
        </div>
        <div class="flex flex-col">
          <div class="flex flex-col md:flex-row gap-5">
            <div class="my-3 text-sm">
              <v-text-field
                label="Prénom"
                id="prenom"
                required
                :rules="nomRules"
                v-model="eleve.prenom"
              ></v-text-field>
            </div>
            <div class="my-3 text-sm">
              <v-text-field
                label="Nom"
                id="nom"
                :rules="nomRules"
                required
                v-model="eleve.nom"
              ></v-text-field>
            </div>
          </div>
          <div class="my-3 text-sm">
            <v-radio-group v-model="eleve.sexe" row :rules="[(v) => !!v]">
              <v-radio id="M" value="M" name="sexe" required>
                <template v-slot:label>
                  <div>
                    <img src="@/assets/studentM.svg" class="w-10" />
                  </div>
                </template>
              </v-radio>

              <v-radio id="F" value="F" name="sexe" required>
                <template v-slot:label>
                  <div>
                    <img src="@/assets/studentF.svg" class="w-10" />
                  </div>
                </template>
              </v-radio>
            </v-radio-group>
          </div>
        </div>
        <div class="flex flex-row-reverse justify-between">
          <div>
            <button
              type="submit"
              class="font-medium bg-bleu text-gray-50 text-sm py-2.5 px-5 rounded-lg hover:bg-bleuHover focus:outline-none"
            >
              {{ updating ? "Modifier" : "Ajouter" }}
            </button>
          </div>
          <div
            id="deleteEleve"
            @click="onDeleteEleve"
            class="cursor-pointer font-medium border border-red-400 text-red-400 text-sm py-2.5 px-5 rounded-lg hover:bg-red-400 hover:text-gray-50 focus:outline-none"
            v-show="updating"
          >
            Effacer
          </div>
        </div>
      </div>
    </v-form>
  </v-dialog>
</template>

<script>
export default {
  name: "ModalAddEleve",
  emits: ["closeRequest"],
  props: { updatedEleve: Object, value: Boolean },

  methods: {
    closeRequest() {
      this.$emit("closeRequest");
    },
    onSubmit() {
      if (this.$refs.form.validate()) {
        this.$store.dispatch("addEleve", {
          ...this.eleve,
          classe: this.classe,
        });
        this.closeRequest();
      }
    },
    onDeleteEleve() {
      this.$store.dispatch("deleteEleve", this.eleve.id);
      this.closeRequest();
    },
  },

  data() {
    return {
      valid: false,
      updating: Object.keys(this.updatedEleve).length !== 0,
      eleve: { ...this.updatedEleve } || {},
      nomRules: [(v) => !!v || "Le nom est requis"],
    };
  },

  computed: {
    classe() {
      return this.$store.getters.getOneClasse(this.$route.params.classeid);
    },
  },
};
</script>
